camera {                   
	location <(4/3)/2, 0.5, -1>
	look_at <(4/3)/2, 0.5, 0>
}

light_source {<1, 3, -5> color rgb 1}

// Use the same resolution for all images

// Step 1                  
#declare makeSkyLayer = 0; // then rename card.bmp to sky.bmp                  
// Step 2
#declare makeTreeLayer = 0; // use +FT +UA and then rename card.tga to tree.tga
// Step 3
#declare makeBallsLayer = 0; // use +FT +UA and then rename card.tga to balls.tga
// Step 4
#declare makeSnowmanLayer = 0; // use +FT +UA and then rename card.tga to snowman.tga
// Step 5
#declare finalRendering = 1;

#include "filters.inc"                                

#declare BrightSky = pigment {
    granite
    color_map {
    	[0.0 color rgb <0, 0.4, 1>]
    	[0.5 color rgb <0, 0.8, 2>]
    }                                 
    scale 0.01
}

#declare DarkSky = pigment {
    granite
    color_map {
    	[0.0 color rgb <0, 0.4, 1>*0.5]
    	[0.5 color rgb <0, 0.8, 2>*0.5]
    }                                 
    scale 0.01
}

#declare Snow = pigment{
	granite
    color_map {
    	[0.0 color rgb 1]
    	[0.5 color rgb <0.9, 0.9, 1>*3]
    }                                 
    scale 0.01  
}

#declare SnowAndSky = plane{
	-z, 0 
	texture {
    	pigment {
    		gradient y
    		pigment_map {
        		[0.0 Snow]
            	[0.4 BrightSky]
            	[1.0 DarkSky]
        	}
        	turbulence 0.05
    	}     
    }
    scale<1, 1.2, 1>              
    translate -y*0.1
	no_shadow
}                   

#declare Happy = text {
	ttf "curlz.ttf" "Happy New Year!" 0.01, 0
	pigment {color rgb<1, 1, 0>*1.5}
	no_shadow
}

#declare BrightGreen = pigment {
    granite
    color_map {
    	[0.0 color rgb <0, 1.0, 0.6>*0.7]
    	[0.5 color rgb <0, 2.0, 1.0>*0.7]
    }                                 
    scale 0.01
}

#declare DarkGreen = pigment {
    granite
    color_map {
    	[0.0 color rgb <0, 1.0, 0.8>*0.35]
    	[0.5 color rgb <0, 2.0, 1.0>*0.35]
    }                                 
    scale 0.01
}

#declare TreePigment = pigment {
	gradient y
	pigment_map {
		[0.0 BrightGreen]
		[0.4 DarkGreen]
	}
} 

#declare TreePart = difference{
	cylinder{0, <0, 1, 0>, 1}
	torus{1, 1 translate y*1}
	
	clipped_by{plane{-y, 0 translate 0.1}}
	hollow                                                  
	translate -y*0.1                         
}

#declare Balls = union {
	sphere{0, 0.1 pigment{color rgb<1, 0, 0>} finish{ambient 0.45 phong 0.5} rotate<-5, 0, 5> translate<-0.4, 1.4, 0>}

	sphere{<-1, -0.12, 0>, 0.06 pigment{color rgb<1, 0, 0>} finish{ambient 0.45 phong 0.5} rotate -y*10}
	sphere{<-1, -0.17, 0>, 0.08 pigment{color rgb<1, 0.3, 0>} finish{ambient 0.45 phong 0.5} rotate -y*70}
	sphere{<-1, -0.17, 0>, 0.07 pigment{color rgb<1, 0, 0.4>} finish{ambient 0.45 phong 0.5} rotate -y*90}
	sphere{<-1, -0.16, 0>, 0.065 pigment{color rgb<1, 0.2, 0.2>} finish{ambient 0.45 phong 0.5} rotate -y*110}
	
	sphere{<-1.3, -0.78, 0>, 0.075 pigment{color rgb<1, 0, 0.7>} finish{ambient 0.45 phong 0.5} rotate -y*20}
	sphere{<-1.2, -0.75, 0>, 0.065 pigment{color rgb<1, 0.5, 0.2>} finish{ambient 0.45 phong 0.5} rotate -y*50}
	sphere{<-1, -0.78, 0>, 0.065 pigment{color rgb<1, 0.3, 0>} finish{ambient 0.45 phong 0.5} rotate -y*70}
	sphere{<-1, -0.80, 0>, 0.08 pigment{color rgb<1, 0, 0.4>} finish{ambient 0.45 phong 0.5} rotate -y*95}
	sphere{<-0.93, -0.78, 0>, 0.06 pigment{color rgb<1, 0.2, 0>} finish{ambient 0.45 phong 0.5} rotate -y*124}
	
	sphere{<-1.64, -1.4, 0>, 0.06 pigment{color rgb<1, 0, 0.3>} finish{ambient 0.45 phong 0.5} rotate -y*25}
	sphere{<-1.5, -1.4, 0>, 0.075 pigment{color rgb<1, 0.3, 0.5>} finish{ambient 0.45 phong 0.5} rotate -y*50}
	sphere{<-1.47, -1.38, 0>, 0.065 pigment{color rgb<1, 0, 0.4>} finish{ambient 0.45 phong 0.5} rotate -y*74}
	sphere{<-1.5, -1.38, 0>, 0.08 pigment{color rgb<1, 0, 0>} finish{ambient 0.45 phong 0.5} rotate -y*90}
	sphere{<-1.5, -1.37, 0>, 0.068 pigment{color rgb<1, 0.1, 0.3>} finish{ambient 0.45 phong 0.5} rotate -y*105}	
	sphere{<-1.37, -1.34, 0>, 0.06 pigment{color rgb<1, 0, 0.5>} finish{ambient 0.45 phong 0.5} rotate -y*123}
	
	scale<1, 1/1.4, 1>
	translate <0.4, 0.06, 0>
	rotate<-5, 0, 5> translate y*1 
	no_shadow
}                

#declare Tree = union {
	object{TreePart scale<1, 1.2, 1> pigment{BrightGreen} finish{ambient 0.2 phong 0} rotate<-5, 0, 5> translate y*1}
	object{TreePart scale 1.5 pigment{TreePigment} finish{ambient 0.3 phong 0} rotate<-2, 0, 3> translate y*0.5} 
	object{TreePart scale 2 pigment{TreePigment} finish{ambient 0.3 phong 0} rotate<-1, 0, 2> translate y*0}
	object{TreePart scale 2.4 pigment{TreePigment} finish{ambient 0.3 phong 0} translate -y*0.5}
	no_shadow
}   

#declare Snowman = union {    
	// body
	sphere{<0, 0.3, 0>, 0.3}
	sphere{<0, 0.7, 0>, 0.2}
	sphere{<0, 0.97, 0>, 0.14}
	
	// hands
	sphere{<-0.25, 0.73, 0>, 0.1}
	sphere{<0.25, 0.73, 0>, 0.1}
	
	// bucket
	cone{0, 0.13, <0, 0.2, 0>, 0.07 rotate <7, 0, 6> translate<-0.01, 1.06, 0> pigment{color rgb<0.7, 0.8, 1>} finish{ambient 0.1 phong 0.4}}
	
	// eyes
	sphere{<0, 1, -0.16>, 0.02 rotate y*25 pigment{color rgb 0}}
	sphere{<0, 1, -0.16>, 0.02 rotate -y*25 pigment{color rgb 0}}
	
	// nose
	cone{0, 0.04, <0, 0, -0.2>, 0 rotate x*15 rotate y*5 translate<0, 0.97, -0.1> pigment{color rgb<1, 0.4, 0.4>*1.3}}
	
	// mouth
	difference{
		torus{0.05, 0.01 rotate x*90}
		plane{-y, 0}
		pigment{color rgb<1, 0.2, 0.2>}
		
		translate<0, 0.96, -0.13>
	}
	
	pigment {color rgb<1, 1, 1.1>}
	finish{ambient 0.2 phong 0.2}
	normal{bumps 0.3 scale 0.001}
	no_shadow
} 

#if(makeSkyLayer)
	object{SnowAndSky}
#end

#if(makeTreeLayer = 1)
	object{Tree scale <0.2, 0.3, 0.2> scale 0.9 translate<0.4, 0.32, 0>}
#end

#if(makeBallsLayer)
	object{Balls scale <0.2, 0.3, 0.2> scale 0.9 translate<0.4, 0.32, 0>}
#end

#if(makeSnowmanLayer)
	light_group {
		light_source {<0, 0, 1> color rgb<1, 1, 1.4>}
		light_source {<0.8, -0.5, -0.05> color rgb<1, 1, 1.4>*0.8}
		light_source {<0.5, 3, -5> color rgb<1, 1, 1.1>*1.4}
		object{Snowman scale<0.5, 0.45, 0.5> rotate<4, 15, 0>translate<0.9, 0.1, 0>} 
		global_lights off
	}
#end

#if(finalRendering = 1)
	#declare skyTxt = pigment {
		image_map{    
			sys "sky.bmp" 
			map_type 0
			interpolate 0
			once
		} 
		scale <4/3, 1, 1>
	} 

	#declare snowmanTxt = pigment {
		image_map{    
			tga "snowman.tga" 
			map_type 0
			interpolate 0
			once
		} 
		scale <4/3, 1, 1>
	}

	#declare treeTxt = pigment {
		image_map{    
			tga "tree.tga" 
			map_type 0
			interpolate 0
			once
		} 
		scale <4/3, 1, 1>
	}

	#declare ballsTxt = pigment {
		image_map{    
			tga "balls.tga" 
			map_type 0
			interpolate 0
			once
		} 
		scale <4/3, 1, 1>
	}
 
	// Happy New Year
	object{Happy scale 0.1 translate<0.55, 0.78, -0.05> no_shadow}

	// snowman
	union {Signac(snowmanTxt, 320, 240, finish{ambient 0.4 phong 0.1}) no_shadow translate -z*0.05}         

	// sky
	union {
		Pollock(skyTxt, 200, 150, finish{ambient 0.35 phong 0.3})
		plane{-z, 0 pigment{skyTxt} finish{ambient 0.3}}
	} 

	// tree
	union {Pollock(treeTxt, 240, 180, finish{ambient 0.35 phong 0.3}) translate -z*0.04 no_shadow}

	// balls
	union {Signac(ballsTxt, 240, 180, finish{ambient 0.4 phong 0.1}) no_shadow translate -z*0.05}
#end
